import type { Plugin } from "vite";
interface PrerenderPluginOptions {
    prerenderScript?: string;
    renderTarget?: string;
    additionalPrerenderRoutes?: string[];
}
export declare function PrerenderPlugin({ prerenderScript, renderTarget, additionalPrerenderRoutes, }?: PrerenderPluginOptions): Plugin;
interface HTMLRoutingMiddlewareOptions {
    fallback?: string;
}
/**
 * Vite's preview server won't route to anything but `/index.html` without
 * a file extension, e.g., `/tutorial` won't serve `/tutorial/index.html`.
 * This leads to some surprises & hydration issues, so we'll fix it ourselves.
 */
export declare function HTMLRoutingMiddlewarePlugin({ fallback, }?: HTMLRoutingMiddlewareOptions): Plugin;
export {};
